/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

/* Arbres préfixes (trie)

   Tableau associatif avec clés de type char* et valeurs de type int.
*/

#include "prelude.h"

#ifndef TRIE
#define TRIE

typedef struct Trie trie;

trie *trie_create(void);
  // un dictionnaire vide
void trie_put(trie *t, char *s, int v);
  // ajoute/écrase une entrée pour s avec la valeur v
trie *trie_find(trie *t, char *s);
  // renvoie le noeud correspondant à s, s'il existe, et NULL sinon
bool trie_contains(trie *t, char *s);
  // y a-t-il une entrée pour s
int trie_get(trie *t, char *s);
  // la valeur associée à s (suppose s dans le dictionnaire)
int trie_prefix(trie *t, char *s);
  // la longueur du plus grand préfixe de s présent dans t
void trie_delete(trie *t);

#endif
